#ifndef _QQDEF_H
#define _QQDEF_H

#include <time.h>
#include <unistd.h>
typedef unsigned int uint;
typedef unsigned short ushort;
typedef unsigned char uchar;


#define MIN(a,b)(a>b?b:a )
#define KB(a) a*1024
#define MB(a) a*KB(1024)
#define CN_TIME(a) a
//#define CN_TIME(a) (a+15*3600) //from New York Time to Beijing Time

#ifdef __WIN32__
#define SLEEP(a)	_sleep(a*1000);
#define USLEEP(a)	_sleep(a);
#else
#define SLEEP(a)	sleep(a);
#define USLEEP(a)	usleep(a*1000);
#define stricmp		strcasecmp
#endif

#define MAX_LOOP_PACKET 32
#define MAX_COMMAND 0x0200
#define MAX_BUDDY 1200	//Ѹ
#define MAX_QUN	128	//Ⱥ
#define MAX_QUN_MEMBER 800	//Ⱥ800Ա
#define MAX_GROUP 128	//
#define MAX_EVENT 128	//¼
#define USER_INFO_LEN 256
#define MAX_USER_INFO 38
#define SIGNITURE_LEN 128	//100
#define TOKEN_LEN 128		//56
#define ACCOUNT_LEN 64		//
#define NICKNAME_LEN 32		//12
#define ALIAS_LEN 16		//8
#define PATH_LEN 1024

typedef struct token{
	short	len;
	uchar	data[TOKEN_LEN];
}token;

//#define QQ_VERSION	0x1205	//
#define QQ_VERSION	0x115b	//

enum QQSTATUS{
	QQ_NONE = 0x00,
	QQ_ONLINE = 0x0a,
	QQ_OFFLINE = 0x14,
	QQ_AWAY = 0x1e,
	QQ_BUSY = 0x32,
	QQ_KILLME = 0x3C,
	QQ_QUIET = 0x46,
	QQ_HIDDEN = 0x28
};

enum MESSAGE_TYPE{
	MT_BUDDY,
	MT_QUN,
	MT_SYSTEM,
	MT_NEWS,
	MT_QUN_MEMBER
};

#define	MSG_CONTENT_LEN KB(4)
typedef struct qqmessage{
	ushort	msg_id;
	uchar	msg_type;
	ushort	msg_seq;
	char	msg_content[MSG_CONTENT_LEN];
	uint	msg_time;
	uint	qun_number;
	uint	from;
	char	auto_reply;
	char	slice_count;
	char	slice_no;
}qqmessage;

struct qqclient;
extern void buddy_msg_callback ( struct qqclient* qq, uint uid, time_t t, char* msg );
extern void qun_msg_callback ( struct qqclient* qq, uint uid, uint int_uid,
	time_t t, char* msg );

#endif
